	.file	"cache_as_ram_auto.c"
	.section .rom.text
	.type	cmos_read, @function
cmos_read:
	xorl	%ecx, %ecx
	testb	%al, %al
	jns	.L2
	movb	$2, %cl
	addl	$-128, %eax
.L2:
	leal	112(%ecx), %edx
#APP
	outb %al, %dx
#NO_APP
	leal	113(%ecx), %edx
#APP
	inb %dx, %al
#NO_APP
	movzbl	%al, %eax
	ret
	.size	cmos_read, .-cmos_read
	.type	cmos_write, @function
cmos_write:
	xorl	%ecx, %ecx
	testb	%dl, %dl
	pushl	%ebx
	movl	%eax, %ebx
	movl	%edx, %eax
	jns	.L6
	movb	$2, %cl
	addl	$-128, %eax
.L6:
	leal	112(%ecx), %edx
#APP
	outb %al, %dx
#NO_APP
	leal	113(%ecx), %edx
	movl	%ebx, %eax
#APP
	outb %al, %dx
#NO_APP
	popl	%ebx
	ret
	.size	cmos_write, .-cmos_write
.globl failover_process
	.type	failover_process, @function
failover_process:
	pushl	%ebp
	movl	$48, %eax
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$24, %esp
	call	cmos_read
	movl	%eax, %edx
	andl	$2, %edx
	cmpl	$0, 48(%esp)
	movl	%edx, 20(%esp)
	jne	.L12
	movl	$27, %ecx
#APP
	rdmsr
#NO_APP
	movl	%eax, %ebx
	movl	$1, %ebp
	andb	$1, %bh
	jne	.L20
.L12:
	cmpl	$0, 20(%esp)
	jmp	.L217
.L209:
	movl	%ecx, %eax
	jmp	.L88
.L20:
	movl	$3320, %ebx
	movl	%ebp, 16(%esp)
	movl	$-2147483648, %eax
	movl	%ebx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	$3324, %esi
	movl	%esi, %edx
#APP
	inl %dx, %eax
#NO_APP
	movl	%eax, %ecx
	andl	$65535, %eax
	sete	%dl
	cmpl	$65535, %eax
	sete	%al
	orl	%edx, %eax
	testb	$1, %al
	jne	.L79
	movl	%ecx, %eax
	shrl	$16, %eax
	cmpl	$65535, %eax
	je	.L79
	testl	%eax, %eax
	je	.L79
	movl	$-2147483636, %eax
	movl	%ebx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movb	$-2, %dl
#APP
	inb %dx, %al
#NO_APP
	andl	$127, %eax
	cmpb	$1, %al
	ja	.L36
	movl	$-2147483596, %eax
	movl	%ebx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
.L216:
#APP
	inb %dx, %al
#NO_APP
	testb	%al, %al
	movb	%al, 15(%esp)
	je	.L36
	movzbl	15(%esp), %ecx
	movl	$3320, %esi
	movl	%esi, %edx
	movl	%ecx, %eax
	andl	$-4, %eax
	orl	$-2147483648, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %edx
	orw	$3324, %dx
#APP
	inb %dx, %al
#NO_APP
	cmpb	$8, %al
	jne	.L40
	leal	2(%ecx), %eax
	movl	%esi, %edx
	movzbl	%al,%ecx
	andl	$3840, %eax
	sall	$16, %eax
	orl	%eax, %ecx
	movl	%ecx, %ebx
	andl	$-4, %ebx
	orl	$-2147483648, %ebx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %edx
	andl	$2, %edx
	addw	$3324, %dx
	movw	%dx, 10(%esp)
#APP
	inw %dx, %ax
#NO_APP
	movl	%eax, %ecx
	movl	%esi, %edx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %eax
	movzwl	10(%esp), %edx
#APP
	outw %ax, %dx
#NO_APP
	movl	%ebx, %eax
	movl	%esi, %edx
#APP
	outl %eax, %dx
#NO_APP
	movzwl	10(%esp), %edx
#APP
	inw %dx, %ax
#NO_APP
	movl	%eax, %ecx
	shrw	$13, %ax
	testw	%ax, %ax
	jne	.L40
	movl	%ebp, %eax
	andl	$-32, %ecx
	movl	%ebp, %edi
	andl	$31, %eax
	andl	$31, %edi
	movl	%esi, %edx
	orl	%eax, %ecx
	sall	$15, %edi
	movl	%ecx, %eax
	shrw	$5, %ax
	andl	$31, %eax
	addl	%eax, %ebp
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %eax
	movzwl	10(%esp), %edx
#APP
	outw %ax, %dx
#NO_APP
	shrw	$10, %cx
	movl	%ecx, %eax
	andl	$1, %eax
	cmpl	$1, %eax
	sbbl	%esi, %esi
	andl	$4, %esi
	addl	$4, %esi
.L56:
	movzbl	15(%esp), %eax
	movl	%edi, %ebx
	shrl	$4, %ebx
	addl	%esi, %eax
	movzbl	%al,%ecx
	andl	$3840, %eax
	orl	%ecx, %ebx
	sall	$16, %eax
	orl	%eax, %ebx
	movl	%ebx, %ecx
	movl	%ebx, (%esp)
	movl	$3320, %ebx
	andl	$-4, %ecx
	movl	%ebx, %edx
	orl	$-2147483648, %ecx
	movl	%ecx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	(%esp), %edx
	andl	$2, %edx
	addw	$3324, %dx
	movw	%dx, (%esp)
#APP
	inw %dx, %ax
#NO_APP
	movzwl	%ax, %eax
	testb	$64, %al
	movl	%eax, 4(%esp)
	jne	.L79
	testl	$272, %eax
	je	.L58
	orl	$272, %eax
	movl	%ebx, %edx
	movl	%eax, 4(%esp)
	movl	%ecx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	4(%esp), %eax
	movl	(%esp), %edx
#APP
	outw %ax, %dx
#NO_APP
	movl	%ecx, %eax
	movl	%ebx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	(%esp), %edx
#APP
	inw %dx, %ax
#NO_APP
	movzwl	%ax, %eax
	testl	$272, %eax
	movl	%eax, 4(%esp)
	jne	.L36
.L58:
	testb	$32, 4(%esp)
	je	.L56
	jmp	.L36
.L40:
	movzbl	15(%esp), %eax
	movl	$3320, %edx
	incl	%eax
	movzbl	%al,%ecx
	andl	$3840, %eax
	sall	$16, %eax
	orl	%eax, %ecx
	movl	%ecx, %eax
	andl	$-4, %eax
	orl	$-2147483648, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %edx
	orw	$3324, %dx
	jmp	.L216
.L36:
	cmpl	%ebp, 16(%esp)
	jne	.L20
.L64:
.L79:
	xorl	%ecx, %ecx
.L89:
	movl	%ecx, %eax
	movl	$3320, %edx
	shrl	$4, %eax
	andl	$-4, %eax
	orl	$-2147483648, %eax
#APP
	outl %eax, %dx
#NO_APP
	movb	$-4, %dl
#APP
	inl %dx, %eax
#NO_APP
	cmpl	$57151710, %eax
	je	.L209
	addl	$4096, %ecx
	cmpl	$268431360, %ecx
	jbe	.L89
	orl	$-1, %eax
.L88:
	movl	%eax, %esi
	movl	$3320, %ebx
	shrl	$4, %esi
	movl	%ebx, %edx
	movl	%esi, %eax
	andl	$268435452, %eax
	orl	$-2147483616, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	$3324, %ecx
	movl	$4097, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %eax
	movl	%ebx, %edx
	andl	$268435452, %eax
	orl	$-2147483612, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	$4353, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %ecx
	movl	%ebx, %edx
	orl	$4, %ecx
	movl	%ecx, %eax
	andl	$-4, %eax
	orl	$-2147483648, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%ecx, %edx
	movl	$1, %eax
	andl	$2, %edx
	addw	$3324, %dx
#APP
	outw %ax, %dx
#NO_APP
	movl	$4097, %edx
#APP
	inb %dx, %al
	outb %al, %dx
#NO_APP
	movl	$4353, %edx
#APP
	inb %dx, %al
	outb %al, %dx
#NO_APP
	movl	$-1, %eax
	movb	$4, %dl
#APP
	outb %al, %dx
#NO_APP
	movl	$-128, %ebx
	movl	%ebx, %eax
#APP
	outb %al, $128
#NO_APP
	movl	$88, %ecx
	movb	$2, %dl
	movl	%ecx, %eax
#APP
	outb %al, %dx
#NO_APP
	movl	%ebx, %eax
#APP
	outb %al, $128
#NO_APP
	movl	$-79, %ecx
	movb	$3, %dl
	movl	%ecx, %eax
#APP
	outb %al, %dx
#NO_APP
	movl	%ebx, %eax
#APP
	outb %al, $128
#NO_APP
	movl	$6, %ecx
	xorb	%dl, %dl
	movl	%ecx, %eax
#APP
	outb %al, %dx
#NO_APP
	movl	%ebx, %eax
#APP
	outb %al, $128
#NO_APP
	movl	$1000000, %ecx
.L120:
	movl	$-128, %eax
#APP
	outb %al, $128
#NO_APP
	movl	$4353, %edx
#APP
	inb %dx, %al
#NO_APP
	testb	%al, %al
	jne	.L210
	decl	%ecx
	jne	.L120
	jmp	.L128
.L210:
#APP
	inb %dx, %al
#NO_APP
.L128:
	movl	$-2147479432, %ebx
	movl	$3320, %ecx
	movl	%ebx, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	$3327, %edi
	movl	%edi, %edx
#APP
	inb %dx, %al
#NO_APP
	movl	%eax, %esi
	movl	%ecx, %edx
	movl	%ebx, %eax
	orl	$32, %esi
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %eax
	movl	%edi, %edx
#APP
	outb %al, %dx
#NO_APP
	movb	$-96, %bl
	movl	%ecx, %edx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	$3324, %esi
	movl	%esi, %edx
#APP
	inl %dx, %eax
#NO_APP
	movl	%eax, %edi
	movl	%ecx, %edx
	movl	%ebx, %eax
	orl	$1, %edi
#APP
	outl %eax, %dx
#NO_APP
	movl	%edi, %eax
	movl	%esi, %edx
#APP
	outl %eax, %dx
#NO_APP
	movb	$-92, %bl
	movl	%ecx, %edx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
#APP
	inl %dx, %eax
#NO_APP
	movl	%eax, %edi
	movl	%ecx, %edx
	movl	%ebx, %eax
	orl	$65536, %edi
#APP
	outl %eax, %dx
#NO_APP
	movl	%edi, %eax
	movl	%esi, %edx
#APP
	outl %eax, %dx
#NO_APP
	movb	$-120, %bl
	movl	%ecx, %edx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
#APP
	inb %dx, %al
#NO_APP
	movl	%ebx, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	$-1, %ebx
	movl	%esi, %edx
	movl	%ebx, %eax
#APP
	outb %al, %dx
#NO_APP
	movl	$-2147479412, %edi
	movl	%ecx, %edx
	movl	%edi, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
#APP
	inb %dx, %al
#NO_APP
	movl	%edi, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	%ebx, %eax
	movl	%esi, %edx
#APP
	outb %al, %dx
#NO_APP
	movl	$-2147479408, %ebx
	movl	%ecx, %edx
	movl	%ebx, %eax
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
#APP
	inw %dx, %ax
#NO_APP
	movl	%eax, %edi
	movl	%ecx, %edx
	movl	%ebx, %eax
	orw	$32767, %di
#APP
	outl %eax, %dx
#NO_APP
	movl	%edi, %eax
	movl	%esi, %edx
#APP
	outw %ax, %dx
#NO_APP
	movl	$-2147434388, %eax
	movl	%ecx, %edx
#APP
	outl %eax, %dx
#NO_APP
	movl	%esi, %edx
#APP
	inl %dx, %eax
#NO_APP
	testb	$16, %al
	je	.L182
	testb	$32, %al
	jne	.L182
	cmpl	$0, 20(%esp)
	jne	.L16
.L182:
	movl	$13, %eax
	call	cmos_read
	testb	$-128, %al
	je	.L191
	xorl	%esi, %esi
	movl	$49, %edi
	movl	$73, %ebx
.L196:
	movl	%edi, %eax
	incl	%edi
	call	cmos_read
	movzbl	%al, %eax
	addl	%eax, %esi
	decb	%bl
	jns	.L196
	movl	$123, %eax
	andl	$65535, %esi
	call	cmos_read
	movzbl	%al, %ebx
	movl	$124, %eax
	xorl	$65535, %esi
	sall	$8, %ebx
	call	cmos_read
	movzbl	%al, %eax
	orl	%eax, %ebx
	cmpl	%ebx, %esi
	je	.L190
.L191:
	movl	$48, %eax
	call	cmos_read
	movl	%eax, %edx
	andl	$12, %edx
	orl	$48, %edx
	movzbl	%dl, %eax
	movl	$48, %edx
	call	cmos_write
.L190:
	movl	$48, %eax
	call	cmos_read
	testb	$1, %al
	movl	%eax, %edx
	je	.L198
	andl	$15, %edx
.L198:
	andl	$-4, %edx
	movl	%edx, %eax
	shrb	$4, %al
	cmpb	$2, %al
	ja	.L199
	orl	$2, %edx
.L199:
	movl	%edx, %eax
	shrb	$4, %al
	cmpb	$2, %al
	ja	.L200
	addl	$16, %edx
	jmp	.L201
.L200:
	andl	$-4, %edx
.L201:
	movzbl	%dl, %ebx
	movl	$48, %edx
	movl	%ebx, %eax
	call	cmos_write
	testb	$2, %bl
.L217:
	je	.L18
.L16:
	movl	44(%esp), %eax
	movl	48(%esp), %ebx
#APP
	jmp __normal_image
#NO_APP
.L18:
	movl	44(%esp), %eax
	movl	48(%esp), %ebx
#APP
	jmp __fallback_image
#NO_APP
	addl	$24, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	ret
	.size	failover_process, .-failover_process
.globl cache_as_ram_main
	.type	cache_as_ram_main, @function
cache_as_ram_main:
	jmp	failover_process
	.size	cache_as_ram_main, .-cache_as_ram_main
	.section	.note.GNU-stack,"",@progbits
	.ident	"GCC: (GNU) 3.4.6 (Debian 3.4.6-9)"
