# 1 "crt0.S"
# 1 "<built-in>"
# 1 "<command line>"

# 1 "/usr/src/coreboot-h8dme-fam10-200912/targets/supermicro/h8dme_fam10/h8dme_fam10/failover/settings.h" 1
# 3 "<command line>" 2
# 1 "crt0.S"
# 24 "crt0.S"
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/arch/i386/include/arch/asm.h" 1
# 25 "crt0.S" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/arch/i386/include/arch/intel.h" 1
# 26 "crt0.S" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/include/console/loglevel.h" 1
# 27 "crt0.S" 2






.section ".rom.data", "a", @progbits
.section ".rom.text", "ax", @progbits

 movb $0x01, %al ; outb %al, $0x80

# 1 "crt0_includes.h" 1
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/16bit/entry16.inc" 1
# 29 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/16bit/entry16.inc"
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/arch/i386/include/arch/rom_segs.h" 1
# 30 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/16bit/entry16.inc" 2
.code16
.globl _start
.type _start, @function

_start:
 cli

 movl %eax, %ebp







 xorl %eax, %eax
 movl %eax, %cr3
# 94 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/16bit/entry16.inc"
 movw %cs, %ax
 shlw $4, %ax
 movw $gdtptr16_offset, %bx
 subw %ax, %bx
 data32 lgdt %cs:(%bx)

 movl %cr0, %eax
 andl $0x7FFAFFD1, %eax
 orl $0x60000001, %eax
 movl %eax, %cr0


 movl %ebp, %eax


 data32 ljmp $0x08, $__protected_start





.align 4
.globl gdtptr16
gdtptr16:
 .word gdt_end - gdt -1
 .long gdt

.globl _estart
_estart:
 .code32
# 2 "crt0_includes.h" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/32bit/entry32.inc" 1





 .code32

 .align 4
.globl gdtptr




gdt:
gdtptr:
 .word gdt_end - gdt -1
 .long gdt
 .word 0


 .word 0xffff, 0x0000
 .byte 0x00, 0x9b, 0xcf, 0x00


 .word 0xffff, 0x0000
 .byte 0x00, 0x93, 0xcf, 0x00

gdt_end:
# 42 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/32bit/entry32.inc"
 .align 4
.globl protected_start
protected_start:

 lgdt %cs:gdtptr
 ljmp $0x08, $__protected_start

__protected_start:

 movl %eax, %ebp

 movb $0x10, %al ; outb %al, $0x80

 movw $0x10, %ax
 movw %ax, %ds
 movw %ax, %es
 movw %ax, %ss
 movw %ax, %fs
 movw %ax, %gs


 movl %ebp, %eax
# 3 "crt0_includes.h" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/x86/16bit/reset16.inc" 1
 .section ".reset"
 .code16
.globl reset_vector
reset_vector:
 .byte 0xe9
 .int _start - ( . + 2 )






 . = 0x8;
 .code32
 jmp protected_start
 .previous
# 4 "crt0_includes.h" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/arch/i386/lib/id.inc" 1
 .section ".id", "a", @progbits

 .globl __id_start
__id_start:
vendor:
 .asciz "Supermicro"
part:
 .asciz "H8DME (Fam10)"
.long __id_end + 128 - vendor
.long __id_end + 128 - part
.long 0x100000
 .globl __id_end

__id_end:
.previous
# 5 "crt0_includes.h" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/southbridge/nvidia/mcp55/romstrap.inc" 1
# 22 "/usr/src/coreboot-h8dme-fam10-200912/src/southbridge/nvidia/mcp55/romstrap.inc"
 .section ".romstrap", "a", @progbits


 .globl __romstrap_start
__romstrap_start:
rstables:
 .long 0x2b16d065
 .long 0x0
 .long 0x0
 .long linkedlist

linkedlist:
 .long 0x0003001C
 .long 0x08000000
 .long 0x00000000
 .long 0xFFFFFFFF

 .long 0xFFFFFFFF
 .long 0xFFFFFFFF
 .long 0xFFFFFFFF
 .long 0xFFFFFFFF

 .long 0x81543266
 .long 0x000000E0

 .long 0x002309CE
 .long 0x00E08100

rspointers:
 .long rstables
 .long rstables
 .long rstables
 .long rstables

 .globl __romstrap_end

__romstrap_end:
.previous
# 6 "crt0_includes.h" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc" 1
# 37 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc"
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/include/cpu/x86/mtrr.h" 1
# 38 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc" 2
# 1 "/usr/src/coreboot-h8dme-fam10-200912/src/include/cpu/amd/mtrr.h" 1
# 39 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc" 2
# 47 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc"
 movl %eax, %ebp



cache_as_ram_setup:

 movb $0xA0, %al
 outb %al, $0x80


 movl %cr4, %eax
 orl $(3<<9), %eax
 movl %eax, %cr4


 cvtsi2sd %ebx, %xmm3
 movl $0x01, %eax
 cpuid

 andl $0x0ff00f00, %eax

 roll $0x10, %eax
 cvtsi2sd %eax, %xmm1
 movl $0x0f000010, %eax
 cvtsi2sd %eax, %xmm2
 cvtsd2si %xmm3, %ebx





 movl $0x2ff, %ecx
 rdmsr
 andl $(1 << 11), %eax
 movl %eax, %ebx

 comisd %xmm2, %xmm1; jb CAR_FAM10_out_post_errata





 movl $0x1b, %ecx
 rdmsr
 bt $8, %eax
 jnc CAR_FAM10_out


 movl $0x8000c06c, %eax
 movw $0xcf8, %dx
 outl %eax, %dx
 addw $4, %dx
 inl %dx, %eax
 btr $0, %eax
 outl %eax, %dx


 movl $0x8000c144, %eax
 movw $0xcf8, %dx
 outl %eax, %dx
 addw $4, %dx
 movl $0, %eax
 outl %eax, %dx

 movl $0x8000c140, %eax
 movw $0xcf8, %dx
 outl %eax, %dx
 addw $4, %dx
 movl $3, %eax
 outl %eax, %dx

CAR_FAM10_out:



 movl $0xc001102a, %ecx
 rdmsr
 bts $15, %eax
 wrmsr




 movl $0xC001102A, %ecx


 rdmsr


 bts $35, %eax


 wrmsr



CAR_FAM10_out_post_errata:


enable_fixed_mtrr_dram_modify:
 movl $0xC0010010, %ecx
 rdmsr
 andl $(~((1 << 18) | (1 << 20))), %eax
 orl $(1 << 19), %eax
 wrmsr


 xorl %edx, %edx
 movl $fixed_mtrr_msr, %esi

clear_fixed_var_mtrr:
 lodsl (%esi), %eax
 testl %eax, %eax
 jz clear_fixed_var_mtrr_out

 movl %eax, %ecx
 xorl %eax, %eax
 wrmsr

 jmp clear_fixed_var_mtrr
clear_fixed_var_mtrr_out:







.macro extractmask segs, reg
.if \segs <= 0




 xorl \reg, \reg
.else
 comisd %xmm2, %xmm1; jb 1f

.if \segs == 1
 movl $0x1e000000, \reg
.elseif \segs == 2
 movl $0x1e1e0000, \reg
.elseif \segs == 3
 movl $0x1e1e1e00, \reg
.elseif \segs >= 4
 movl $0x1e1e1e1e, \reg
.endif
 jmp 2f
1:
.if \segs == 1
 movl $0x06000000, \reg
.elseif \segs == 2
 movl $0x06060000, \reg
.elseif \segs == 3
 movl $0x06060600, \reg
.elseif \segs >= 4
 movl $0x06060606, \reg
.endif
2:
.endif
.endm




.macro simplemask carsize, windowoffset
 .set gas_bug_workaround,(((\carsize - \windowoffset) / 0x1000) - 4)
 extractmask gas_bug_workaround, %eax
 .set gas_bug_workaround,(((\carsize - \windowoffset) / 0x1000))
 extractmask gas_bug_workaround, %edx





.endm
# 236 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc"
 movl $0x268, %ecx
 simplemask 0xc000, 0x8000
 wrmsr



 movl $0x269, %ecx
 simplemask 0xc000, 0
 wrmsr


 movl $0xC001001A, %ecx
 xorl %edx, %edx
 movl $(((16777216) + 0x007fffff) & ~0x007fffff) , %eax
 wrmsr
# 265 "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/car/cache_as_ram.inc"
 movl $0x202, %ecx
 xorl %edx, %edx
 movl $(0xfffe0000 | 6), %eax
 wrmsr

 movl $0x203, %ecx
 movl $0xff, %edx
 comisd %xmm2, %xmm1; jb wbcache_post_fam10_setup
 movl $0xffff, %edx
wbcache_post_fam10_setup:
 movl $(~(0x20000 - 1) | 0x800), %eax
 wrmsr




 movl $0x2ff, %ecx
 xorl %edx, %edx

 movl $0x00000c00, %eax
 wrmsr


 movl $0xC0010010, %ecx
 rdmsr
 orl $((1 << 20) | (1 << 18)), %eax
 wrmsr


 movb $0xA1, %al
 outb %al, $0x80


 movl %cr0, %eax
 andl $0x9fffffff, %eax
 movl %eax, %cr0

 comisd %xmm2, %xmm1; jb fam10_end_part1


 movl $0x1b, %ecx
 rdmsr
 bt $8, %eax
 jnc CAR_FAM10_ap
fam10_end_part1:

 movb $0xA2, %al
 outb %al, $0x80



 cld
 movl $(0xd0000 - 0xc000), %esi
 movl $(0xc000 >> 2), %ecx
 rep lodsl


 movl $(0xd0000 - 0xc000), %edi
 movl $(0xc000 >> 2), %ecx
 xorl %eax, %eax
 rep stosl




 movl $((0xd0000 - 0xc000) + 0xc000 - 0x4000), %eax
 movl %eax, %esp

 movb $0xA3, %al
 outb %al, $0x80

 jmp CAR_FAM10_ap_out
CAR_FAM10_ap:






 movl %ebx, %esi


 movl $0x80000008, %eax
 cpuid
 shrl $12, %ecx
 andl $0x0f, %ecx
 movl %ecx, %edi


 movl $1, %eax
 cpuid
 shrl $24, %ebx


 movl $0xc001001f, %ecx
 rdmsr
 movl %edi, %ecx
 bt $(54-32), %edx
 jc roll_cfg
 rolb %cl, %bl
roll_cfg:


 movl $0x400, %eax
 mull %ebx
 movl $((0xd0000 - 0xc000) + (0xc000 - 0x4000)/2), %esp
 subl %eax, %esp


 movl %esi, %ebx

 movb $0xA4, %al
 outb %al, $0x80

CAR_FAM10_ap_out:

 movb $0xA5, %al
 outb %al, $0x80


 movl %cr4, %eax
 andl $~(3<<9), %eax
 movl %eax, %cr4


 movl %ebp, %eax


 movl %esp, %ebp
 pushl %ebx
 pushl %eax
 call cache_as_ram_main


 movb $0xAF, %al
 outb %al, $0x80

fixed_mtrr_msr:
 .long 0x250, 0x258, 0x259
 .long 0x268, 0x269, 0x26A
 .long 0x26B, 0x26C, 0x26D
 .long 0x26E, 0x26F
var_mtrr_msr:
 .long 0x200, 0x201, 0x202, 0x203
 .long 0x204, 0x205, 0x206, 0x207
 .long 0x208, 0x209, 0x20A, 0x20B
 .long 0x20C, 0x20D, 0x20E, 0x20F
var_iorr_msr:
 .long 0xC0010016, 0xC0010017, 0xC0010018, 0xC0010019
mem_top:
 .long 0xC001001A, 0xC001001D
 .long 0x000

cache_as_ram_setup_out:
# 7 "crt0_includes.h" 2
# 1 "././auto.inc" 1
 .file "cache_as_ram_auto.c"
 .section .rom.text
 .type cmos_read, @function
cmos_read:
 xorl %ecx, %ecx
 testb %al, %al
 jns .L2
 movb $2, %cl
 addl $-128, %eax
.L2:
 leal 112(%ecx), %edx
#APP
 outb %al, %dx
#NO_APP
 leal 113(%ecx), %edx
#APP
 inb %dx, %al
#NO_APP
 movzbl %al, %eax
 ret
 .size cmos_read, .-cmos_read
 .type cmos_write, @function
cmos_write:
 xorl %ecx, %ecx
 testb %dl, %dl
 pushl %ebx
 movl %eax, %ebx
 movl %edx, %eax
 jns .L6
 movb $2, %cl
 addl $-128, %eax
.L6:
 leal 112(%ecx), %edx
#APP
 outb %al, %dx
#NO_APP
 leal 113(%ecx), %edx
 movl %ebx, %eax
#APP
 outb %al, %dx
#NO_APP
 popl %ebx
 ret
 .size cmos_write, .-cmos_write
.globl failover_process
 .type failover_process, @function
failover_process:
 pushl %ebp
 movl $48, %eax
 pushl %edi
 pushl %esi
 pushl %ebx
 subl $24, %esp
 call cmos_read
 movl %eax, %edx
 andl $2, %edx
 cmpl $0, 48(%esp)
 movl %edx, 20(%esp)
 jne .L12
 movl $27, %ecx
#APP
 rdmsr
#NO_APP
 movl %eax, %ebx
 movl $1, %ebp
 andb $1, %bh
 jne .L20
.L12:
 cmpl $0, 20(%esp)
 jmp .L217
.L209:
 movl %ecx, %eax
 jmp .L88
.L20:
 movl $3320, %ebx
 movl %ebp, 16(%esp)
 movl $-2147483648, %eax
 movl %ebx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl $3324, %esi
 movl %esi, %edx
#APP
 inl %dx, %eax
#NO_APP
 movl %eax, %ecx
 andl $65535, %eax
 sete %dl
 cmpl $65535, %eax
 sete %al
 orl %edx, %eax
 testb $1, %al
 jne .L79
 movl %ecx, %eax
 shrl $16, %eax
 cmpl $65535, %eax
 je .L79
 testl %eax, %eax
 je .L79
 movl $-2147483636, %eax
 movl %ebx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movb $-2, %dl
#APP
 inb %dx, %al
#NO_APP
 andl $127, %eax
 cmpb $1, %al
 ja .L36
 movl $-2147483596, %eax
 movl %ebx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
.L216:
#APP
 inb %dx, %al
#NO_APP
 testb %al, %al
 movb %al, 15(%esp)
 je .L36
 movzbl 15(%esp), %ecx
 movl $3320, %esi
 movl %esi, %edx
 movl %ecx, %eax
 andl $-4, %eax
 orl $-2147483648, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %edx
 orw $3324, %dx
#APP
 inb %dx, %al
#NO_APP
 cmpb $8, %al
 jne .L40
 leal 2(%ecx), %eax
 movl %esi, %edx
 movzbl %al,%ecx
 andl $3840, %eax
 sall $16, %eax
 orl %eax, %ecx
 movl %ecx, %ebx
 andl $-4, %ebx
 orl $-2147483648, %ebx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %edx
 andl $2, %edx
 addw $3324, %dx
 movw %dx, 10(%esp)
#APP
 inw %dx, %ax
#NO_APP
 movl %eax, %ecx
 movl %esi, %edx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %eax
 movzwl 10(%esp), %edx
#APP
 outw %ax, %dx
#NO_APP
 movl %ebx, %eax
 movl %esi, %edx
#APP
 outl %eax, %dx
#NO_APP
 movzwl 10(%esp), %edx
#APP
 inw %dx, %ax
#NO_APP
 movl %eax, %ecx
 shrw $13, %ax
 testw %ax, %ax
 jne .L40
 movl %ebp, %eax
 andl $-32, %ecx
 movl %ebp, %edi
 andl $31, %eax
 andl $31, %edi
 movl %esi, %edx
 orl %eax, %ecx
 sall $15, %edi
 movl %ecx, %eax
 shrw $5, %ax
 andl $31, %eax
 addl %eax, %ebp
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %eax
 movzwl 10(%esp), %edx
#APP
 outw %ax, %dx
#NO_APP
 shrw $10, %cx
 movl %ecx, %eax
 andl $1, %eax
 cmpl $1, %eax
 sbbl %esi, %esi
 andl $4, %esi
 addl $4, %esi
.L56:
 movzbl 15(%esp), %eax
 movl %edi, %ebx
 shrl $4, %ebx
 addl %esi, %eax
 movzbl %al,%ecx
 andl $3840, %eax
 orl %ecx, %ebx
 sall $16, %eax
 orl %eax, %ebx
 movl %ebx, %ecx
 movl %ebx, (%esp)
 movl $3320, %ebx
 andl $-4, %ecx
 movl %ebx, %edx
 orl $-2147483648, %ecx
 movl %ecx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl (%esp), %edx
 andl $2, %edx
 addw $3324, %dx
 movw %dx, (%esp)
#APP
 inw %dx, %ax
#NO_APP
 movzwl %ax, %eax
 testb $64, %al
 movl %eax, 4(%esp)
 jne .L79
 testl $272, %eax
 je .L58
 orl $272, %eax
 movl %ebx, %edx
 movl %eax, 4(%esp)
 movl %ecx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl 4(%esp), %eax
 movl (%esp), %edx
#APP
 outw %ax, %dx
#NO_APP
 movl %ecx, %eax
 movl %ebx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl (%esp), %edx
#APP
 inw %dx, %ax
#NO_APP
 movzwl %ax, %eax
 testl $272, %eax
 movl %eax, 4(%esp)
 jne .L36
.L58:
 testb $32, 4(%esp)
 je .L56
 jmp .L36
.L40:
 movzbl 15(%esp), %eax
 movl $3320, %edx
 incl %eax
 movzbl %al,%ecx
 andl $3840, %eax
 sall $16, %eax
 orl %eax, %ecx
 movl %ecx, %eax
 andl $-4, %eax
 orl $-2147483648, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %edx
 orw $3324, %dx
 jmp .L216
.L36:
 cmpl %ebp, 16(%esp)
 jne .L20
.L64:
.L79:
 xorl %ecx, %ecx
.L89:
 movl %ecx, %eax
 movl $3320, %edx
 shrl $4, %eax
 andl $-4, %eax
 orl $-2147483648, %eax
#APP
 outl %eax, %dx
#NO_APP
 movb $-4, %dl
#APP
 inl %dx, %eax
#NO_APP
 cmpl $57151710, %eax
 je .L209
 addl $4096, %ecx
 cmpl $268431360, %ecx
 jbe .L89
 orl $-1, %eax
.L88:
 movl %eax, %esi
 movl $3320, %ebx
 shrl $4, %esi
 movl %ebx, %edx
 movl %esi, %eax
 andl $268435452, %eax
 orl $-2147483616, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl $3324, %ecx
 movl $4097, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %eax
 movl %ebx, %edx
 andl $268435452, %eax
 orl $-2147483612, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl $4353, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %ecx
 movl %ebx, %edx
 orl $4, %ecx
 movl %ecx, %eax
 andl $-4, %eax
 orl $-2147483648, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %ecx, %edx
 movl $1, %eax
 andl $2, %edx
 addw $3324, %dx
#APP
 outw %ax, %dx
#NO_APP
 movl $4097, %edx
#APP
 inb %dx, %al
 outb %al, %dx
#NO_APP
 movl $4353, %edx
#APP
 inb %dx, %al
 outb %al, %dx
#NO_APP
 movl $-1, %eax
 movb $4, %dl
#APP
 outb %al, %dx
#NO_APP
 movl $-128, %ebx
 movl %ebx, %eax
#APP
 outb %al, $128
#NO_APP
 movl $88, %ecx
 movb $2, %dl
 movl %ecx, %eax
#APP
 outb %al, %dx
#NO_APP
 movl %ebx, %eax
#APP
 outb %al, $128
#NO_APP
 movl $-79, %ecx
 movb $3, %dl
 movl %ecx, %eax
#APP
 outb %al, %dx
#NO_APP
 movl %ebx, %eax
#APP
 outb %al, $128
#NO_APP
 movl $6, %ecx
 xorb %dl, %dl
 movl %ecx, %eax
#APP
 outb %al, %dx
#NO_APP
 movl %ebx, %eax
#APP
 outb %al, $128
#NO_APP
 movl $1000000, %ecx
.L120:
 movl $-128, %eax
#APP
 outb %al, $128
#NO_APP
 movl $4353, %edx
#APP
 inb %dx, %al
#NO_APP
 testb %al, %al
 jne .L210
 decl %ecx
 jne .L120
 jmp .L128
.L210:
#APP
 inb %dx, %al
#NO_APP
.L128:
 movl $-2147479432, %ebx
 movl $3320, %ecx
 movl %ebx, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl $3327, %edi
 movl %edi, %edx
#APP
 inb %dx, %al
#NO_APP
 movl %eax, %esi
 movl %ecx, %edx
 movl %ebx, %eax
 orl $32, %esi
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %eax
 movl %edi, %edx
#APP
 outb %al, %dx
#NO_APP
 movb $-96, %bl
 movl %ecx, %edx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl $3324, %esi
 movl %esi, %edx
#APP
 inl %dx, %eax
#NO_APP
 movl %eax, %edi
 movl %ecx, %edx
 movl %ebx, %eax
 orl $1, %edi
#APP
 outl %eax, %dx
#NO_APP
 movl %edi, %eax
 movl %esi, %edx
#APP
 outl %eax, %dx
#NO_APP
 movb $-92, %bl
 movl %ecx, %edx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
#APP
 inl %dx, %eax
#NO_APP
 movl %eax, %edi
 movl %ecx, %edx
 movl %ebx, %eax
 orl $65536, %edi
#APP
 outl %eax, %dx
#NO_APP
 movl %edi, %eax
 movl %esi, %edx
#APP
 outl %eax, %dx
#NO_APP
 movb $-120, %bl
 movl %ecx, %edx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
#APP
 inb %dx, %al
#NO_APP
 movl %ebx, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl $-1, %ebx
 movl %esi, %edx
 movl %ebx, %eax
#APP
 outb %al, %dx
#NO_APP
 movl $-2147479412, %edi
 movl %ecx, %edx
 movl %edi, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
#APP
 inb %dx, %al
#NO_APP
 movl %edi, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl %ebx, %eax
 movl %esi, %edx
#APP
 outb %al, %dx
#NO_APP
 movl $-2147479408, %ebx
 movl %ecx, %edx
 movl %ebx, %eax
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
#APP
 inw %dx, %ax
#NO_APP
 movl %eax, %edi
 movl %ecx, %edx
 movl %ebx, %eax
 orw $32767, %di
#APP
 outl %eax, %dx
#NO_APP
 movl %edi, %eax
 movl %esi, %edx
#APP
 outw %ax, %dx
#NO_APP
 movl $-2147434388, %eax
 movl %ecx, %edx
#APP
 outl %eax, %dx
#NO_APP
 movl %esi, %edx
#APP
 inl %dx, %eax
#NO_APP
 testb $16, %al
 je .L182
 testb $32, %al
 jne .L182
 cmpl $0, 20(%esp)
 jne .L16
.L182:
 movl $13, %eax
 call cmos_read
 testb $-128, %al
 je .L191
 xorl %esi, %esi
 movl $49, %edi
 movl $73, %ebx
.L196:
 movl %edi, %eax
 incl %edi
 call cmos_read
 movzbl %al, %eax
 addl %eax, %esi
 decb %bl
 jns .L196
 movl $123, %eax
 andl $65535, %esi
 call cmos_read
 movzbl %al, %ebx
 movl $124, %eax
 xorl $65535, %esi
 sall $8, %ebx
 call cmos_read
 movzbl %al, %eax
 orl %eax, %ebx
 cmpl %ebx, %esi
 je .L190
.L191:
 movl $48, %eax
 call cmos_read
 movl %eax, %edx
 andl $12, %edx
 orl $48, %edx
 movzbl %dl, %eax
 movl $48, %edx
 call cmos_write
.L190:
 movl $48, %eax
 call cmos_read
 testb $1, %al
 movl %eax, %edx
 je .L198
 andl $15, %edx
.L198:
 andl $-4, %edx
 movl %edx, %eax
 shrb $4, %al
 cmpb $2, %al
 ja .L199
 orl $2, %edx
.L199:
 movl %edx, %eax
 shrb $4, %al
 cmpb $2, %al
 ja .L200
 addl $16, %edx
 jmp .L201
.L200:
 andl $-4, %edx
.L201:
 movzbl %dl, %ebx
 movl $48, %edx
 movl %ebx, %eax
 call cmos_write
 testb $2, %bl
.L217:
 je .L18
.L16:
 movl 44(%esp), %eax
 movl 48(%esp), %ebx
#APP
 jmp __normal_image
#NO_APP
.L18:
 movl 44(%esp), %eax
 movl 48(%esp), %ebx
#APP
 jmp __fallback_image
#NO_APP
 addl $24, %esp
 popl %ebx
 popl %esi
 popl %edi
 popl %ebp
 ret
 .size failover_process, .-failover_process
.globl cache_as_ram_main
 .type cache_as_ram_main, @function
cache_as_ram_main:
 jmp failover_process
 .size cache_as_ram_main, .-cache_as_ram_main
 .section .note.GNU-stack,"",@progbits
 .ident "GCC: (GNU) 3.4.6 (Debian 3.4.6-9)"
# 8 "crt0_includes.h" 2
# 39 "crt0.S" 2
