#include <device/device.h>
#include <device/pci.h>
#include "/usr/src/coreboot-h8dme-fam10-200912/src/drivers/i2c/i2cmux2/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/mainboard/supermicro/h8dme_fam10/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/northbridge/amd/amdfam10/root_complex/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/cpu/amd/socket_F_1207/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/southbridge/nvidia/mcp55/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/superio/winbond/w83627hf/chip.h"
#include "/usr/src/coreboot-h8dme-fam10-200912/src/northbridge/amd/amdfam10/chip.h"

/* pass 0 */
struct device _dev3;
struct device _dev6;
struct device _dev5;
struct device _dev8;
struct device _dev9;
struct device _dev10;
struct device _dev54;
struct device _dev55;
struct device _dev56;
struct device _dev57;
struct device _dev58;
struct device _dev59;
struct device _dev60;
struct device _dev61;
struct device _dev62;
struct device _dev12;
struct device _dev13;
struct device _dev26;
struct device _dev30;
struct device _dev33;
struct device _dev34;
struct device _dev35;
struct device _dev36;
struct device _dev37;
struct device _dev38;
struct device _dev39;
struct device _dev41;
struct device _dev42;
struct device _dev43;
struct device _dev44;
struct device _dev49;
struct device _dev50;
struct device _dev51;
struct device _dev52;
struct device _dev53;
struct device _dev15;
struct device _dev16;
struct device _dev17;
struct device _dev18;
struct device _dev19;
struct device _dev20;
struct device _dev21;
struct device _dev22;
struct device _dev23;
struct device _dev24;
struct device _dev25;
struct device _dev28;
struct device _dev29;
struct device _dev32;
struct device _dev40;
struct device _dev45;
struct device _dev46;
struct device _dev47;
struct device _dev48;

/* pass 1 */
struct mainboard_config mainboard_info_0;
struct device **last_dev_p = &_dev62.next;
struct device dev_root = {
	.ops = &default_dev_ops_root,
	.bus = &dev_root.link[0],
	.path = { .type = DEVICE_PATH_ROOT },
	.enabled = 1,
	.links = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.dev=&dev_root,
			.link = 0,
			.children = &_dev3,
		},
	},
	.chip_ops = &mainboard_ops,
	.chip_info = &mainboard_info_0,
	.next = &_dev3,
};
struct northbridge_amd_amdfam10_root_complex_config northbridge_amd_amdfam10_root_complex_info_2;
struct device _dev3 = {
	.ops = 0,
	.bus = &dev_root.link[0],
	.path = {.type=DEVICE_PATH_APIC_CLUSTER,{.apic_cluster={ .cluster = 0x0 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev3,
			.children = &_dev5,
		},
	},
	.links = 1,
	.sibling = &_dev6,
	.chip_ops = &northbridge_amd_amdfam10_root_complex_ops,
	.chip_info = &northbridge_amd_amdfam10_root_complex_info_2,
	.next=&_dev5
};
struct device _dev6 = {
	.ops = 0,
	.bus = &dev_root.link[0],
	.path = {.type=DEVICE_PATH_PCI_DOMAIN,{.pci_domain={ .domain = 0x0 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev6,
			.children = &_dev8,
		},
	},
	.links = 1,
	.chip_ops = &northbridge_amd_amdfam10_root_complex_ops,
	.chip_info = &northbridge_amd_amdfam10_root_complex_info_2,
	.next=&_dev8
};
struct cpu_amd_socket_F_1207_config cpu_amd_socket_F_1207_info_4;
struct device _dev5 = {
	.ops = 0,
	.bus = &_dev3.link[0],
	.path = {.type=DEVICE_PATH_APIC,{.apic={ .apic_id = 0x0 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &cpu_amd_socket_F_1207_ops,
	.chip_info = &cpu_amd_socket_F_1207_info_4,
	.next=&_dev6
};
struct northbridge_amd_amdfam10_config northbridge_amd_amdfam10_info_7;
struct device _dev8 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x18,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev8,
		},
		[1] = {
			.link = 1,
			.dev = &_dev8,
		},
		[2] = {
			.link = 2,
			.dev = &_dev8,
			.children = &_dev12,
		},
	},
	.links = 3,
	.sibling = &_dev54,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev12
};
struct device _dev54 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x18,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev55,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev55
};
struct device _dev55 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x18,2)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev56,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev56
};
struct device _dev56 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x18,3)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev57,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev57
};
struct device _dev57 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x18,4)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev58,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev58
};
struct device _dev58 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x19,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev59,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev59
};
struct device _dev59 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x19,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev60,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev60
};
struct device _dev60 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x19,2)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev61,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev61
};
struct device _dev61 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x19,3)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev62,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
	.next=&_dev62
};
struct device _dev62 = {
	.ops = 0,
	.bus = &_dev6.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x19,4)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &northbridge_amd_amdfam10_ops,
	.chip_info = &northbridge_amd_amdfam10_info_7,
};
struct southbridge_nvidia_mcp55_config southbridge_nvidia_mcp55_info_11	= {
	.ide0_enable = 1,
	.sata0_enable = 1,
	.sata1_enable = 1,
	.mac_eeprom_addr = 0x51,
	.mac_eeprom_smbus = 3,
};

struct device _dev12 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x0,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev13,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev13
};
struct device _dev13 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x1,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev13,
			.children = &_dev15,
		},
	},
	.links = 1,
	.sibling = &_dev26,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev15
};
struct device _dev26 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x1,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev26,
			.children = &_dev28,
		},
		[1] = {
			.link = 1,
			.dev = &_dev26,
			.children = &_dev32,
		},
	},
	.links = 2,
	.sibling = &_dev33,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev28
};
struct device _dev33 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x2,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev34,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev34
};
struct device _dev34 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x2,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev35,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev35
};
struct device _dev35 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x4,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev36,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev36
};
struct device _dev36 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x5,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev37,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev37
};
struct device _dev37 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x5,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev38,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev38
};
struct device _dev38 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x5,2)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev39,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev39
};
struct device _dev39 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x6,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev39,
			.children = &_dev40,
		},
	},
	.links = 1,
	.sibling = &_dev41,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev40
};
struct device _dev41 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x6,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev42,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev42
};
struct device _dev42 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x8,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev43,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev43
};
struct device _dev43 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x9,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev44,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev44
};
struct device _dev44 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xa,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev44,
			.children = &_dev45,
		},
	},
	.links = 1,
	.sibling = &_dev49,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev45
};
struct device _dev49 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xb,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev50,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev50
};
struct device _dev50 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xc,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev51,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev51
};
struct device _dev51 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xd,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev52,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev52
};
struct device _dev52 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xe,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev53,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev53
};
struct device _dev53 = {
	.ops = 0,
	.bus = &_dev8.link[2],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0xf,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev54
};
struct superio_winbond_w83627hf_config superio_winbond_w83627hf_info_14;
struct device _dev15 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x0 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.resources = 3,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x3f0},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x6},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_DRQ, .index=0x74, .base=0x2},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev16,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev16
};
struct device _dev16 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x1 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.resources = 2,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x378},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x7},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev17,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev17
};
struct device _dev17 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x2 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.resources = 2,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x3f8},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x4},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev18,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev18
};
struct device _dev18 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x3 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.resources = 2,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x2f8},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x3},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev19,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev19
};
struct device _dev19 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x5 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.resources = 4,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x60},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x62, .base=0x64},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x1},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x72, .base=0xc},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev20,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev20
};
struct device _dev20 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x6 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.resources = 1,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x62, .base=0x100},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev21,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev21
};
struct device _dev21 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x7 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.resources = 3,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x220},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x62, .base=0x300},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x9},
	 },
	.link = {
	},
	.links = 0,
	.sibling = &_dev22,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev22
};
struct device _dev22 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x8 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev23,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev23
};
struct device _dev23 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0x9 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev24,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev24
};
struct device _dev24 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0xa }}},
	.enabled = 0,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev25,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev25
};
struct device _dev25 = {
	.ops = 0,
	.bus = &_dev13.link[0],
	.path = {.type=DEVICE_PATH_PNP,{.pnp={ .port = 0x2e, .device = 0xb }}},
	.enabled = 1,
	.on_mainboard = 1,
	.resources = 2,
	.resource = {
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO, .index=0x60, .base=0x290},
		{ .flags=IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IRQ, .index=0x70, .base=0x5},
	 },
	.link = {
	},
	.links = 0,
	.chip_ops = &superio_winbond_w83627hf_ops,
	.chip_info = &superio_winbond_w83627hf_info_14,
	.next=&_dev26
};
struct drivers_i2c_i2cmux2_config drivers_i2c_i2cmux2_info_27;
struct device _dev28 = {
	.ops = 0,
	.bus = &_dev26.link[0],
	.path = {.type=DEVICE_PATH_I2C,{.i2c={ .device = 0x48 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev29,
	.chip_ops = &drivers_i2c_i2cmux2_ops,
	.chip_info = &drivers_i2c_i2cmux2_info_27,
	.next=&_dev29
};
struct device _dev29 = {
	.ops = 0,
	.bus = &_dev26.link[0],
	.path = {.type=DEVICE_PATH_I2C,{.i2c={ .device = 0x49 }}},
	.enabled = 0,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &drivers_i2c_i2cmux2_ops,
	.chip_info = &drivers_i2c_i2cmux2_info_27,
	.next=&_dev32
};
struct device _dev32 = {
	.ops = 0,
	.bus = &_dev26.link[1],
	.path = {.type=DEVICE_PATH_I2C,{.i2c={ .device = 0x51 }}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.next=&_dev33
};
struct device _dev40 = {
	.ops = 0,
	.bus = &_dev39.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x6,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev41
};
struct device _dev45 = {
	.ops = 0,
	.bus = &_dev44.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x0,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev46,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev46
};
struct device _dev46 = {
	.ops = 0,
	.bus = &_dev44.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x0,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
		[0] = {
			.link = 0,
			.dev = &_dev46,
			.children = &_dev47,
		},
	},
	.links = 1,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev47
};
struct device _dev47 = {
	.ops = 0,
	.bus = &_dev46.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x4,0)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.sibling = &_dev48,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev48
};
struct device _dev48 = {
	.ops = 0,
	.bus = &_dev46.link[0],
	.path = {.type=DEVICE_PATH_PCI,{.pci={ .devfn = PCI_DEVFN(0x4,1)}}},
	.enabled = 1,
	.on_mainboard = 1,
	.link = {
	},
	.links = 0,
	.chip_ops = &southbridge_nvidia_mcp55_ops,
	.chip_info = &southbridge_nvidia_mcp55_info_11,
	.next=&_dev49
};
